"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initCommander = exports.Templatemanager = void 0;
const chalk = require("chalk");
const list_1 = require("./list");
const clone_1 = require("./clone");
class Templatemanager {
    constructor(program) {
        this.program = program;
        this.init(program);
    }
    init(program) {
        program
            .command("temp")
            .alias("t")
            .description("模版管理")
            .argument("<list | new>", "列出所有模版列表")
            .action(this.handleAction);
    }
    handleAction(cmd, options) {
        switch (cmd) {
            case "list":
                new list_1.RepositoryList(options);
                break;
            case "new":
                new clone_1.RepositoryClone(options);
                break;
            default:
                console.log(chalk.red(`❎ 没有这个命令`), chalk.bgBlue(cmd));
                break;
        }
    }
}
exports.Templatemanager = Templatemanager;
exports.initCommander = (program) => {
    new Templatemanager(program);
};
