import chalk = require("chalk");

const ProgressBar = require("progress");

export class Loading {
    bar: any;
    /**
     * 500ms + 1
     */
    tiems: number;
    /**
     * 最大超时 30s
     */
    timeout: number = 300;
    /**
     *
     */
    total: number = 50;

    constructor() {
        this.bar = new ProgressBar("下载中: [:bar] :rate/bps :percent :etas", { total: this.total, width: 40 });
        this.tiems = 0;
    }

    start() {
        let that = this;
        var timer = setInterval(function () {
            that.tiems++;
            if (that.tiems <= 49) that.bar.tick();

            if (that.bar.complete) {
                console.log(chalk.green("下载完成!"));
                clearInterval(timer);
            }

            if (that.tiems > that.timeout) {
                clearInterval(timer);
                throw new Error("下载超时!!");
            }
        }, 100);
    }

    stop() {
        const len = this.tiems < this.total ? this.total - this.tiems : 1;

        for (let i = 0; i < len; i++) {
            this.bar.tick();
        }
        this.bar.complete = true;
    }

    end() {
        this.bar.clear();
    }
}
